Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
@@ -375,31 +423,1023 @@
 procedure TfrmODBBank.SetupDialog(OrderAction: Integer; const ID: string);
 var
-  tmpResp: TResponse;
+  AnInstance, CurAdd: Integer;
+  AResponse: TResponse;
+  i, j, k, aTNS, aTNSDays, getTest, TestAdded: integer;
+  aStr, aTestYes, aName, aTypeScreen, aSpecimen, aModifier, sub, sub1, x, aTNSString: string;
+  ListItem: TListItem;
+  aList: TStringList;
+  aTests: TStringList;
+begin
+  inherited;
+  aList := TStringList.Create;
+  aTests:= TStringList.Create;
+  try
+  FOrderAction := OrderAction;
+  ReadServerVariables;
+  sub1 := '';
+  aTypeScreen := '';
+  aSpecimen := '^';
+  aModifier := '';
+  if OrderAction in [ORDER_COPY, ORDER_EDIT, ORDER_QUICK] then with Responses, ALabTest do
+    begin
+      AnInstance := NextInstance('ORDERABLE', 0);
+      while AnInstance > 0 do
+        begin
+          AResponse := FindResponseByName('ORDERABLE', AnInstance);
+          if AResponse <> nil then
+            begin
+              sub := GetSubtype(AResponse.EValue);
+              if sub = 't' then
+                begin
+                  SetControl(cboAvailTest,        'ORDERABLE', AnInstance);
+                  ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
+                end
+              else
+                begin
+                  SetControl(cboAvailComp,        'ORDERABLE', AnInstance);
+                  ALabTest := TLabTest.Create(cboAvailComp.ItemID, Responses);
+                end;
+              if ALabTest = nil then Exit;  // Causes access violation
+              if AnInstance = 1 then
+                begin
+                  SetControl(cboReasons,         'REASON' , AnInstance);
+                  SetControl(calWantTime,        'DATETIME', AnInstance);
+                  SetControl(memDiagComment,     'COMMENT', AnInstance);
+                  SetControl(chkConsent,         'YN', AnInstance);
+                  //DetermineCollectionDefaults(Responses);
+                  SetControl(cboCollType,        'COLLECT', AnInstance);
+                  SetControl(cboCollTime,        'START', AnInstance);
+                  SetupCollTimes(cboCollType.ItemID);
+                  SetControl(cboUrgency,         'URGENCY', AnInstance);
+                  SetControl(cboSurgery,         'MISC', AnInstance);
+                  Urgency := cboUrgency.ItemIEN;
+                  if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
+                    begin
+                      cboUrgency.ItemIndex := 0;
+                      Urgency := cboUrgency.ItemIEN;
+                    end;
+                  i := 1 ;
+                  AResponse := Responses.FindResponseByName('COMMENT',i);
+                  while AResponse <> nil do
+                    begin
+                      Comment.Add(AResponse.EValue);
+                      Inc(i);
+                      AResponse := Responses.FindResponseByName('COMMENT',i);
+                    end ;
+                end;
+              if sub = 't' then with ALabTest do      //DIAGNOSTIC TEST
+                begin
+                  Changing := True;
+                  DisableComponentControls;
+                  EnableDiagTestControls;
+                  LRORDERMODE := TORDER_MODE_DIAG;
+                  aList.Clear;
+                  aTestYes := '1';
+                  ExtractTypeScreen(aList, uVBECList);
+                  if aList.Count > 0 then aTypeScreen := aList[0];
+                  aList.Clear;
+                  with lvSelectionList do
+                    begin
+                      ListItem := Items.Add;
+                      ListItem.Caption := piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',2);
+                      ListItem.SubItems.Add('');
+                      ListItem.SubItems.Add('');
+                      ListItem.SubItems.Add('');
+                      ListItem.SubItems.Add(piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1));
+                      if piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1) = aTypeScreen then
+                        begin
+                          lblTNS.Caption := '';
+                          lblTNS.Visible := false;
+                          memMessage.Text := '';
+                          pnlMessage.Visible := false;
+                          uGetTnS := 0;
+                          pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+                        end;
+                    end;
+                  aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+                  uSelectedItems.Add(aStr);
+                  if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+                  {with cboCollType do if Length(ItemID) > 0 then
+                    begin
+                      Responses.Update('COLLECT', 1, ItemID, ItemID) ;
+                      FLastCollType := ItemID;
+                    end;  }
+                  if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+                  if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
+                  if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
+                  LoadCollType(cboCollType);
+                  if (cboCollType.ItemID = 'LC') or (cboCollType.ItemID = 'I') then
+                    if not(ALabTest.LabCanCollect) and OrderForInpatient then
+                      cboCollType.SelectByID('WC')
+                    else if not(ALabTest.LabCanCollect) then
+                      cboCollType.SelectByID('SP');
+                  SetupCollTimes(cboCollType.ItemID);
+                  if cboCollType.ItemID = 'LC' then
+                    begin
+                      with cboCollTime do
+                        if Length(ItemID) > 0 then
+                          begin
+                            Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
+                            FLastLabCollTime := ItemID + U + Text;
+                          end
+                        else if Length(Text) > 0 then
+                          begin
+                            Responses.Update('START', 1, ValidCollTime(Text), Text) ;
+                            FLastLabCollTime := ValidCollTime(Text);
+                          end;
+                    end
+                  else
+                    begin
+                      with calCollTime do
+                        if FMDateTime > 0 then
+                          begin
+                            Responses.Update('START', 1, ValidCollTime(Text), Text);
+                            FLastColltime := ValidCollTime(Text);
+                          end
+                        else
+                          begin
+                            Responses.Update('START', 1, '', '') ;
+                            FLastCollTime := '';
+                          end;
+                    end;
+                  with cboCollType do if Length(ItemID) > 0 then
+                    begin
+                      Responses.Update('COLLECT', 1, ItemID, ItemID) ;
+                      FLastCollType := ItemID;
+                    end;
+                  //if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
+                  memOrder.Text := Responses.OrderText;
+                  Changing := False;
+                  if ObtainCollSamp then
+                    begin
+                      //For BloodBank orders, this condition should never occur
+                    end
+                  else
+                    begin
+                      with ALabTest do
+                        with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                          begin
+                            x := '' ;
+                            for i := 0 to WardComment.Count-1 do
+                            x := x + WardComment.strings[i]+#13#10 ;
+                            pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                            OrderMessage(x) ;
+                          end ;
+                    end;
+                end;
+              if sub = 'c' then with ALabTest do  //COMPONENT
+                begin
+                  Changing := True;
+                  DisableDiagTestControls;
+                  EnableComponentControls;
+                  aTestYes := '0';
+                  LRORDERMODE := TORDER_MODE_COMP;
+                  SetControl(cboModifiers,       'MODIFIER', AnInstance);
+                  SetControl(tQuantity,          'QTY', AnInstance);
+                  uComponentSelected := true;
+                  aList.Clear;
+                  TestAdded := 0;
+                  getTest := 0;
+                  ExtractTests(aList, uVBECList);   //Get Results associated with ordered components
+                    for j := 0 to aList.Count - 1 do
+                      begin
+                        if StrToInt(piece(aList[j],'^',1)) = aLabTest.ItemID then
+                          begin
+                            if uTestsForResults.Count < 1 then getTest := 1;
+                            for k := 0 to uTestsForResults.Count - 1 do
+                              begin
+                                if piece(uTestsForResults[k],'^',1) = piece(aList[j],'^',3) then
+                                  begin
+                                    getTest := 0;
+                                    break;
+                                  end
+                                else getTest := 1;
+                              end;
+                            if getTest = 1 then
+                              begin
+                                uTestsForResults.Add(piece(aList[j],'^',3));
+                                TestAdded := 1;
+                              end;
+                          end;
+                      end;
+                    if TestAdded = 1 then
+                      begin
+                        edtResults.Clear;
+                        aTests.Clear;
+                        GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
+                        QuickCopy(ATests,edtResults);
+                        if edtResults.Lines.Count > 0 then TabResults.Caption := 'Lab Results Available'; //TabResults.ImageIndex := 1;
+                        uRaw.Clear;
+                        GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+                      end;
+                    CurAdd := 1;
+                    if uRaw.Count > 0 then
+                    for j := 0 to uRaw.Count - 1 do
+                      begin
+                        if Length(uRaw[j]) > 0 then Responses.Update('RESULTS', CurAdd, uRaw[j], piece(uRaw[j],'^',1));
+                        Inc(CurAdd);
+                      end;
+                  with lvSelectionList do
+                    begin
+                      ListItem := Items.Add;
+                      ListItem.Caption := piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',2);
+                      ListItem.SubItems.Add(tQuantity.Text);
+                      if length(cboModifiers.ItemID) > 0 then
+                        begin
+                          ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex]);
+                          ListItem.SubItems.Add(IntToStr(cboModifiers.ItemIndex));
+                        end
+                        else
+                          begin
+                            ListItem.SubItems.Add('');
+                            ListItem.SubItems.Add('');
+                          end;
+                      ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
+                    end;
+                  aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+                  uSelectedItems.Add(aStr);
+                  memOrder.Text := Responses.OrderText;
+                  Changing := False;
+                end;
+            end;
+          StatusText('');
+          AnInstance := NextInstance('ORDERABLE', AnInstance);
+        end;  //while AnInstance - ORDERABLE
+      DisableComponentControls;
+      DisableDiagTestControls;
+    end;
+    CurAdd := 1;
+    for i := 0 to uSelectedItems.Count - 1 do
+      begin
+        aName := lvSelectionList.Items[i].Caption;
+        x := uSelectedItems[i];
+        if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
+          begin
+            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+          end
+        else
+          begin
+            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+            if Length(piece(x,'^',3)) > 0 then Responses.Update('QTY', CurAdd, piece(x,'^',3), piece(x,'^',3));
+            if Length(piece(x,'^',4)) > 0 then Responses.Update('MODIFIER', CurAdd, piece(x,'^',4), piece(x,'^',4));
+            if Length(piece(x,'^',5)) > 0 then Responses.Update('SPECSTS', CurAdd, pieces(x,'^',5,7), piece(x,'^',5));
+            if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+            if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+            if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
+              else
+                begin
+                  cboUrgency.ItemIndex := 1;
+                  Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+                  cboUrgencyChange(self);
+                end;
+          end;
+        Inc(CurAdd);
+      end;
+    for i := 0 to lvSelectionList.Items.Count - 1 do
+      begin
+        if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+          begin
+            if uTNSOrders.Count > 0 then
+              begin
+                for j := 0 to uTNSOrders.Count - 1 do
+                  aTNSString := aTNSString + CRLF + uTNSOrders[j];
+                with Application do
+                  begin
+                    NormalizeTopMosts;
+                    aTNSDays := TNSDaysBack;
+                    aTNS :=
+                      MessageBox(PChar(aTNSString + CRLF + CRLF +
+                                 'Do you wish to continue with this request for Type & Screen?'),
+                                 PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
+                                 MB_YESNO);
+                    RestoreTopMosts;
+                    if aTNS = 7 then
+                      begin
+                        lvSelectionList.ItemIndex := i;
+                        lvSelectionListClick(self);
+                        btnRemoveClick(self);
+                        break;
+                      end;
+                  end;
+              end;
+            break;
+          end;
+      end;
+  {if OrderAction in [ORDER_COPY, ORDER_EDIT, ORDER_QUICK] then with Responses, ALabTest do
+    begin
+      if OrderAction in [ORDER_QUICK, ORDER_EDIT] then uQuickInProcess := 1;
+      AnInstance := NextInstance('ORDERABLE', 0);
+      while AnInstance > 0 do
+        begin
+          AResponse := FindResponseByName('ORDERABLE', AnInstance);
+          if AResponse <> nil then
+            begin
+              sub := GetSubtype(AResponse.EValue);
+              if sub = 't' then
+                begin
+                  SetControl(cboAvailTest,        'ORDERABLE', AnInstance);
+                  ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
+                end
+              else
+                begin
+                  SetControl(cboAvailComp,        'ORDERABLE', AnInstance);
+                  ALabTest := TLabTest.Create(cboAvailComp.ItemID, Responses);
+                end;
+              //SetControl(cboTests,           'ORDERABLE', AnInstance);
+              //ALabTest := TLabTest.Create(cboTests.ItemID, Responses);
+              if ALabTest = nil then Exit;  // Causes access violation
+              //sub := GetSubtype(ALabTest.TestName);
+              if AnInstance = 1 then
+                begin
+                  DetermineCollectionDefaults(Responses);
+                  SetControl(cboReasons,         'REASON', AnInstance);
+                  SetControl(chkConsent,         'YN', AnInstance);
+                  SetControl(cboSurgery,         'MISC', AnInstance);
+                  //SetControl(cboCollType,        'COLLECT', AnInstance);
+                  //SetControl(cboCollTime,        'START', AnInstance);
+                  SetControl(calWantTime,        'DATETIME', AnInstance);
+                  //LoadUrgency(cboCollType.ItemID, cboUrgency);
+                  SetControl(cboUrgency,         'URGENCY', AnInstance);
+                  Urgency := cboUrgency.ItemIEN;
+                  if (Urgency = 0) and (cboUrgency.Items.Count = AnInstance) then
+                    begin
+                      cboUrgency.ItemIndex := 0;
+                      Urgency := cboUrgency.ItemIEN;
+                    end;
+                  i := 1 ;
+                  AResponse := Responses.FindResponseByName('COMMENT',i);
+                  while AResponse <> nil do
+                      begin
+                        if Length(AResponse.Evalue) > 0 then
+                          Comment.Add(AResponse.EValue);
+                        Inc(i);
+                        AResponse := Responses.FindResponseByName('COMMENT',i);
+                      end ;
+                end;
+              if sub = 't' then with ALabTest do      //DIAGNOSTIC TEST
+                begin
+                  Changing := True;
+                  DisableComponentControls;
+                  EnableDiagTestControls;
+                  LRORDERMODE := TORDER_MODE_DIAG;
+                  with Responses do
+                    begin
+                      StatusText('Initializing Order');
+                      AResponse := FindResponseByName('ORDERABLE', AnInstance);
+                      if AResponse <> nil then
+                        sub1 := GetSubtype(AResponse.EValue);
+                      if sub1 = 't' then
+                        begin
+                          SetControl(cboAvailTest,       'ORDERABLE', AnInstance);
+                          //SetControl(cboTests,           'ORDERABLE', AnInstance);
+                          //DetermineCollectionDefaults(Responses);   //cboCollType = COLLECT , calCollTime = START
+                          cboAvailTestSelect(self);
+                        end;
+                    end;
+                  Changing := False;
+                  if ObtainCollSamp then
+                    begin
+                      //For BloodBank orders, this condition should never occur
+                    end
+                  else
+                    begin
+                      with ALabTest do
+                        with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                          begin
+                            x := '' ;
+                            for i := 0 to WardComment.Count-1 do
+                            x := x + WardComment.strings[i]+#13#10 ;
+                            pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                            OrderMessage(x) ;
+                          end ;
+                    end;
+                end;
+              if sub = 'c' then with ALabTest do  //COMPONENT
+                begin
+                  Changing := True;
+                  DisableDiagTestControls;
+                  EnableComponentControls;
+                  LRORDERMODE := TORDER_MODE_COMP;
+                  with Responses do
+                    begin
+                      StatusText('Initializing Order');
+                      AResponse := FindResponseByName('ORDERABLE', AnInstance);
+                      if AResponse <> nil then
+                        sub1 := GetSubtype(AResponse.EValue);
+                      if sub1 = 'c' then
+                        begin
+                          SetControl(cboAvailComp,       'ORDERABLE', AnInstance);
+                          //SetControl(cboTests,           'ORDERABLE', AnInstance);
+                          SetControl(cboModifiers,       'MODIFIER', AnInstance);
+                          SetControl(tQuantity,          'QTY', AnInstance);
+                          //DetermineCollectionDefaults(Responses);
+                          cboAvailCompSelect(self);
+                        end;
+                    end;
+                  Changing := False;
+                end;
+              with ALabTest do
+                begin
+                  if ObtainComment then
+                    LoadRequiredComment(FCmtTypes.IndexOf(CurReqComment))
+                  else
+                    DisableCommentPanels;
+                  x := '' ;
+                  for i := 0 to CurWardComment.Count-1 do
+                    x := x + CurWardComment.strings[i]+#13#10 ;
+                  i :=  IndexOfCollSamp(CollSamp);
+                  if i > -1 then with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                    for i := 0 to WardComment.Count-1 do
+                      x := x + WardComment.strings[i]+#13#10 ;
+                  pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                  if Length(x) > 0 then
+                    begin
+                      OrderMessage(x) ;
+                    end;
+                end;
+              StatusText('');
+              Changing := True;
+              //if not(FOrderAction = ORDER_EDIT) then DetermineCollectionDefaults(Responses);
+              Changing := False;
+            end;
+          AnInstance := NextInstance('ORDERABLE', AnInstance);
+        end; //while AnInstance - ORDERABLE
+      DisableComponentControls;
+      DisableDiagTestControls;
+      uQuickInProcess := 0;
+    end;  }
+  finally
+    aList.Free;
+    aTests.Free;
+  end;
+  edtResults.Height := 247;
+  edtInfo.Height := 247;
+  if lvSelectionList.Items.Count > 0 then
+    begin
+      pnlSelectedTests.Visible := True;
+      cmdAccept.Visible := True;
+      memOrder.Visible := True;
+      GroupBox1.Visible := False;
+    end;
+end;
+
+procedure TfrmODBBank.SetOnQuickOrder;
+  var
+  AnInstance: Integer;
+  AResponse: TResponse;
   i: integer;
+  x,sub,sub1,aTNSString: string;
+  aList: TStringList;
+  aGotIt: boolean;
+  aTests: TStringList;
+  ListItem: TListItem;
+  aName, aMsg, aStr, aModifier, aReason, aSurgery, aCollTime, aTestYes, aSpecimen, aTypeScreen: String;
+  CurAdd, j, k, getTest, TestAdded, aMSBOS, aMSBOSContinue, aTNS, aTNSDays: Integer;
 begin
   inherited;
-  ReadServerVariables;
-  if LRFZX <> '' then
-    begin
-      cboCollType.SelectByID(LRFZX);
-      if cboCollType.ItemIndex > -1 then SetupCollTimes(LRFZX);
-    end;
-  if OrderAction in [ORDER_COPY, ORDER_EDIT, ORDER_QUICK] then with Responses, ALabTest do
-   begin
-      SetControl(cboAvailTest,       'ORDERABLE', 1);
-      cboAvailTestSelect(Self);
-      if ALabTest = nil then Exit;  // Causes access violation in FillCollSampleList
-      Changing := True;
-      DetermineCollectionDefaults(Responses);
-      i := 1 ;
-      tmpResp := Responses.FindResponseByName('COMMENT',i);
-      while tmpResp <> nil do
-        begin
-          Comment.Add(tmpResp.EValue);
-          Inc(i);
-          tmpResp := Responses.FindResponseByName('COMMENT',i);
-        end ;
-      Changing := False;
-   end;
+  aList := TStringList.Create;
+  aTests := TStringList.Create;
+  try
+    aModifier := '';
+    aReason := '';
+    aSurgery := '';
+    aCollTime := '';
+    aTestYes := '0';
+    aTypeScreen := '';
+    aSpecimen := '';
+    sub1 := '';
+    ExtractTypeScreen(aList, uVBECList);
+    if aList.Count > 0 then aTypeScreen := aList[0];
+    aList.Clear;
+    Extractspecimen(aList, uVBECList);
+    if aList.Count > 0 then aSpecimen := aList[0];
+    with Responses, ALabTest do
+      begin
+        Changing := True;
+        aGotIt := False;
+        FLastItemID := cboQuick.ItemID;
+        QuickOrder := ExtractInteger(cboQuick.ItemID);
+        with Responses do
+          begin
+            StatusText('Initializing Quick Order');
+            AnInstance := NextInstance('ORDERABLE', 0);
+            while AnInstance > 0 do
+              begin
+                AResponse := FindResponseByName('ORDERABLE', AnInstance);
+                sub := GetSubtype(AResponse.EValue);
+                if sub = 't' then
+                  begin
+                    SetControl(cboAvailTest,        'ORDERABLE', AnInstance);
+                    ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
+                  end
+                else
+                  begin
+                    SetControl(cboAvailComp,        'ORDERABLE', AnInstance);
+                    ALabTest := TLabTest.Create(cboAvailComp.ItemID, Responses);
+                  end;
+                for i := 0 to aList.Count - 1 do
+                  if aList[i] = ALabTest.TestName then
+                    begin
+                      aGotIt := true;
+                      break;
+                    end;
+                if aGotIt = true then
+                  begin
+                    aGotIt := false;
+                    AnInstance := NextInstance('ORDERABLE', AnInstance);
+                    Continue;
+                  end
+                  else
+                    begin
+                      aList.Add(ALabTest.TestName);
+                    end;
+                if AResponse <> nil then
+                  sub1 := GetSubtype(AResponse.EValue);
+                if AnInstance = 1 then
+                  begin
+                    SetControl(cboReasons,         'REASON', AnInstance);
+                    SetControl(calWantTime,        'DATETIME', AnInstance);
+                    SetControl(memDiagComment,     'COMMENT', AnInstance);
+                    SetControl(chkConsent,         'YN', AnInstance);
+                    //DetermineCollectionDefaults(Responses);
+                    SetControl(cboCollType,        'COLLECT', AnInstance);
+                    SetupCollTimes(cboCollType.ItemID);
+                    //SetControl(cboCollTime,        'START', AnInstance);
+                    //LoadUrgency(cboCollType.ItemID, cboUrgency);
+                    SetControl(cboUrgency,         'URGENCY', AnInstance);
+                    Urgency := cboUrgency.ItemIEN;
+                    if (Urgency = 0) and (cboUrgency.Items.Count = AnInstance) then
+                      begin
+                        cboUrgency.ItemIndex := 0;
+                        Urgency := cboUrgency.ItemIEN;
+                        cboUrgencyChange(self);
+                      end;
+                    SetControl(cboSurgery,         'MISC', AnInstance);
+                    if not(ALabTest = nil) then
+                      begin
+                        Urgency := cboUrgency.ItemIEN;
+                        if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
+                          begin
+                            cboUrgency.ItemIndex := 0;
+                            Urgency := cboUrgency.ItemIEN;
+                          end;
+                        i := 1 ;
+                        AResponse := Responses.FindResponseByName('COMMENT',i);
+                        while AResponse <> nil do
+                          begin
+                            Comment.Add(AResponse.EValue);
+                            Inc(i);
+                            AResponse := Responses.FindResponseByName('COMMENT',i);
+                          end ;
+                      end;
+                    if not(cboCollType.ItemID = 'LC') then
+                      begin
+                        if Length(cboCollTime.Text) > 0 then
+                          begin
+                            calCollTime.FMDateTime := StrToFMDateTime(cboCollTime.Text);
+                            FLastCollTime := cboCollTime.Text;
+                          end
+                        else
+                          begin
+                            FLastCollTime := '';
+                          end;
+                      end;
+                  end;
+                if sub1 = 'c' then
+                  begin
+                    DisableDiagTestControls;
+                    EnableComponentControls;
+                    LRORDERMODE := TORDER_MODE_COMP;
+                    SetControl(cboAvailComp,       'ORDERABLE', AnInstance);
+                    SetControl(cboModifiers,       'MODIFIER', AnInstance);
+                    SetControl(tQuantity,          'QTY', AnInstance);
+                    //DetermineCollectionDefaults(Responses);
+                    //Check for and display any associated Lab Results
+                    aList.Clear;
+                    TestAdded := 0;
+                    getTest := 0;
+                    ExtractTests(aList, uVBECList);   //Get Results associated with ordered components
+                      for j := 0 to aList.Count - 1 do
+                        begin
+                          if StrToInt(piece(aList[j],'^',1)) = aLabTest.ItemID then
+                            begin
+                              if uTestsForResults.Count < 1 then getTest := 1;
+                              for k := 0 to uTestsForResults.Count - 1 do
+                                begin
+                                  if piece(uTestsForResults[k],'^',1) = piece(aList[j],'^',3) then
+                                    begin
+                                      getTest := 0;
+                                      break;
+                                    end
+                                  else getTest := 1;
+                                end;
+                              if getTest = 1 then
+                                begin
+                                  uTestsForResults.Add(piece(aList[j],'^',3));
+                                  TestAdded := 1;
+                                end;
+                            end;
+                        end;
+                      if TestAdded = 1 then
+                        begin
+                          edtResults.Clear;
+                          aTests.Clear;
+                          GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
+                          QuickCopy(ATests,edtResults);
+                          if edtResults.Lines.Count > 0 then TabResults.Caption := 'Lab Results Available'; //TabResults.ImageIndex := 1;
+                          uRaw.Clear;
+                          GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+                        end;
+                      CurAdd := 1;
+                      if uRaw.Count > 0 then
+                      for j := 0 to uRaw.Count - 1 do
+                        begin
+                          if Length(uRaw[j]) > 0 then Responses.Update('RESULTS', CurAdd, uRaw[j], piece(uRaw[j],'^',1));
+                          Inc(CurAdd);
+                        end;
+                    aSpecimen := '^';
+                    aTestYes := '0';
+                    aReason := '';
+                    aSurgery := '';
+                    aCollTime := '';
+                    ExtractSpecimen(aList, uVBECList);
+                    if aList.Count > 0 then aSpecimen := aList[0];
+                    if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
+                    if length(cboReasons.ItemID) > 0 then aReason := cboReasons.Items[cboReasons.ItemIndex];
+                    if length(cboSurgery.ItemID) > 0 then aSurgery := cboSurgery.Items[cboSurgery.ItemIndex];
+                    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
+                    if Length(cboSurgery.ItemID) > 0 then
+                      begin
+                        aList.Clear;
+                        ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgey
+                        for i := 0 to aList.Count - 1 do
+                          begin
+                            if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
+                             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+                              begin
+                                aMSBOS := StrToInt(piece(aList[i],'^',4));
+                                if (aMSBOS > 0) and (StrToInt(tQuantity.Text) > aMSBOS) then
+                                  begin
+                                    with Application do
+                                    begin
+                                      NormalizeTopMosts;
+                                      aMSBOSContinue :=
+                                        MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
+                                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
+                                                   + IntToStr(aMSBOS) +
+                                                   ') for the ' + cboSurgery.text +
+                                                   ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
+                                                   PChar('Maximum Number of Units Exceeded'),
+                                                   MB_YESNO);
+                                      RestoreTopMosts;
+                                    end;
+                                    if aMSBOSContinue = 7 then
+                                      begin
+                                        ShowMsg(cboAvailComp.Text + ' has NOT been added to this request.');
+                                        exit;
+                                      end;
+                                  end;
+                              end;
+                          end;
+                      end;
+                    if (uTNSOrders.Count < 1) then //SpecimenNeeded(aList, uVBECList, aLabTest.ItemID) then  //check to see if type and screen is needed
+                      begin
+                        uGetTnS := 1;
+                      end;
+                    aList.Clear;
+                    ExtractSpecimens(aList, uVBECList);    //Get specimen values to pass back to Server
+                    for i := 0 to aList.Count - 1 do
+                      begin
+                        if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
+                          begin
+                            aSpecimen := piece(aList[i],'^',2) + '^' + aSpecimen;
+                            break;
+                          end;
+                      end;
+                    uComponentSelected := true;
+                    with lvSelectionList do
+                      begin
+                        ListItem := Items.Add;
+                        ListItem.Caption := piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',2);
+                        ListItem.SubItems.Add(tQuantity.Text);
+                        if length(cboModifiers.ItemID) > 0 then
+                          begin
+                            ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex]);
+                            ListItem.SubItems.Add(IntToStr(cboModifiers.ItemIndex));
+                          end
+                          else
+                            begin
+                              ListItem.SubItems.Add('');
+                              ListItem.SubItems.Add('');
+                            end;
+                        ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
+                      end;
+                    CurAdd := 1;
+                    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+                    uSelectedItems.Add(aStr);
+                    for i := 0 to uSelectedItems.Count - 1 do
+                      begin
+                        aName := lvSelectionList.Items[i].Caption;
+                        x := uSelectedItems[i];
+                        if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
+                          begin
+                            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+                          end
+                        else
+                          begin
+                            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+                            if Length(piece(x,'^',3)) > 0 then Responses.Update('QTY', CurAdd, piece(x,'^',3), piece(x,'^',3));
+                            if Length(piece(x,'^',4)) > 0 then Responses.Update('MODIFIER', CurAdd, piece(x,'^',4), aModifier);
+                            if Length(piece(x,'^',5)) > 0 then Responses.Update('SPECSTS', CurAdd, pieces(x,'^',5,7), piece(x,'^',5));
+                            if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+                          end;
+                        Inc(CurAdd);
+                      end;
+                    memOrder.Text := Responses.OrderText;
+                    GroupBox1.Visible := False;
+                  aMsg := '';
+                  LRORDERMODE := TORDER_MODE_INFO;
+                  {if uGetTnS = 1 then
+                    begin
+                      lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+                      lblTNS.Visible := true;
+                      memMessage.Text := 'TYPE + SCREEN must be added to order';
+                      memMessage.Visible := false;
+                      pnlMessage.Visible := true;
+                      pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+                    end;  }
+                  {if uGetTnS = 1 then
+                    begin
+                      if responses.QuickOrder < 1 then
+                        begin
+                          for i := 1 to cboAvailTest.Items.Count - 1 do
+                            begin
+                              if piece(cboAvailTest.Items[i],'^',1) = aTypeScreen then
+                                begin
+                                  if piece(aSpecimen,'^',1) = '1' then
+                                    begin
+                                      cboCollTime.Text := calWantTime.Text;
+                                      aCollSave := cboCollTime.Text + '^' + cboCollTime.ItemID + '^' + cboCollType.Text + '^' + cboCollType.ItemID;
+                                      cboCollTime.Text := '';
+                                      cboCollType.Text := '';
+                                      uSpecimen := 1;
+                                    end;
+                                  cboModifiers.Text := '';
+                                  cboAvailTest.SelectByID(aTypeScreen);
+                                  cboTests.SelectByID(aTypeScreen);
+                                  cboTestsClick(self);
+                                  //cboAvailTestSelect(Self);
+                                  uSpecimen := 0;
+                                  cboCollTime.Text := piece(aCollSave,'^',1);
+                                  cboCollType.Text := piece(aCollSave,'^',3);
+                                  aCollSave := '';
+                                  break;
+                                end;
+                            end;
+                          aMsg := 'An order for Type and Screen has been added to this request' + '.';
+                        end
+                        else
+                          begin
+                            lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+                            lblTNS.Visible := true;
+                            memMessage.Text := 'TYPE + SCREEN must be added to order';
+                            memMessage.Visible := false;
+                            pnlMessage.Visible := true;
+                          end;
+                    end;
+                  if (uGetTnS = 1) then
+                    begin
+                      if length(aMsg) > 0 then aMsg := aMsg + crlf + crlf;
+                      ShowMsg(aMsg);
+                    end;  }
+
+                  //cboModifiers.Text := '';
+                  edtResults.Height := 247;
+                  edtInfo.Height := 247;
+                  if lvSelectionList.Items.Count > 0 then
+                    begin
+                      pnlSelectedTests.Visible := True;
+                      cmdAccept.Visible := True;
+                      memOrder.Visible := True;
+                      GroupBox1.Visible := False;
+                    end;
+                  end
+                  else
+                    begin
+                      if sub1 = 't' then
+                      begin
+                        DisableComponentControls;
+                        EnableDiagTestControls;
+                        LRORDERMODE := TORDER_MODE_DIAG;
+                        aTestYes := '1';
+                        SetControl(cboAvailTest,       'ORDERABLE', AnInstance);
+                        //DetermineCollectionDefaults(Responses);   //cboCollType = COLLECT , calCollTime = START
+                        i := 1 ;
+                        AResponse := Responses.FindResponseByName('COMMENT',i);
+                        while AResponse <> nil do
+                          begin
+                            Comment.Add(AResponse.EValue);
+                            Inc(i);
+                            AResponse := Responses.FindResponseByName('COMMENT',i);
+                          end ;
+                        if ObtainCollSamp then
+                          begin
+                          //For BloodBank orders, this condition should never occur
+                          end
+                        else
+                          begin
+                            with ALabTest do
+                              with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                                begin
+                                  x := '' ;
+                                  for i := 0 to WardComment.Count-1 do
+                                  x := x + WardComment.strings[i]+#13#10 ;
+                                  pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                                  OrderMessage(x) ;
+                                end ;
+                          end;
+                        if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+                        with cboCollType do if Length(ItemID) > 0 then
+                          begin
+                            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
+                            FLastCollType := ItemID;
+                          end;
+                        if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
+                          else
+                            begin
+                              cboUrgency.ItemIndex := 1;
+                              Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+                              cboUrgencyChange(self);
+                            end;
+                        if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
+                        if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
+                        LoadCollType(cboCollType);
+                        if (cboCollType.ItemID = 'LC') or (cboCollType.ItemID = 'I') then
+                          if not(ALabTest.LabCanCollect) and OrderForInpatient then
+                            cboCollType.SelectByID('WC')
+                          else if not(ALabTest.LabCanCollect) then
+                            cboCollType.SelectByID('SP');
+                        SetupCollTimes(cboCollType.ItemID);
+                        if cboCollType.ItemID = 'LC' then
+                          begin
+                            with cboCollTime do
+                              if Length(ItemID) > 0 then
+                                begin
+                                  Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
+                                  FLastLabCollTime := ItemID + U + Text;
+                                end
+                              else if Length(Text) > 0 then
+                                begin
+                                  Responses.Update('START', 1, ValidCollTime(Text), Text) ;
+                                  FLastLabCollTime := ValidCollTime(Text);
+                                end;
+                          end
+                        else
+                          begin
+                            with calCollTime do
+                              if FMDateTime > 0 then
+                                begin
+                                  Responses.Update('START', 1, ValidCollTime(Text), Text);
+                                  FLastColltime := ValidCollTime(Text);
+                                end
+                              else
+                                begin
+                                  Responses.Update('START', 1, '', '') ;
+                                  FLastCollTime := '';
+                                end;
+                          end;
+                        if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
+                        with cboCollType do if Length(ItemID) > 0 then
+                          begin
+                            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
+                            FLastCollType := ItemID;
+                          end;
+                        uTestSelected := true;
+                        with lvSelectionList do
+                          begin
+                            ListItem := Items.Add;
+                            ListItem.Caption := piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',2);
+                            ListItem.SubItems.Add('');
+                            ListItem.SubItems.Add('');
+                            ListItem.SubItems.Add('');
+                            ListItem.SubItems.Add(piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1));
+                          end;
+                        CurAdd := 1;
+                        aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + aCollTime + '^' + cboCollType.Text + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces
+                        uSelectedItems.Add(aStr);
+                        for i := 0 to uSelectedItems.Count - 1 do
+                          begin
+                            aName := lvSelectionList.Items[i].Caption;
+                            x := uSelectedItems[i];
+                            if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
+                              begin
+                                if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+                              end;
+                            Inc(CurAdd);
+                          end;
+                        memOrder.Text := Responses.OrderText;
+                      edtResults.Height := 247;
+                      edtInfo.Height := 247;
+                      if lvSelectionList.Items.Count > 0 then
+                        begin
+                          pnlSelectedTests.Visible := True;
+                          cmdAccept.Visible := True;
+                          memOrder.Visible := True;
+                          GroupBox1.Visible := False;
+                        end;
+                      end;
+                    end;
+                  AnInstance := NextInstance('ORDERABLE', AnInstance);
+              end;
+              //Quick Order
+          end;
+        for i := 0 to lvSelectionList.Items.Count - 1 do
+          begin
+            if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+              begin
+                uGetTnS := 0;
+                uDfltUrgency := cboUrgency.ItemID;
+                lblTNS.Caption := '';
+                lblTNS.Visible := false;
+                memMessage.Text := '';
+                pnlMessage.Visible := false;
+                pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+                if uTNSOrders.Count > 0 then
+                  begin
+                    for j := 0 to uTNSOrders.Count - 1 do
+                      aTNSString := aTNSString + CRLF + uTNSOrders[j];
+                    with Application do
+                      begin
+                        NormalizeTopMosts;
+                        aTNSDays := TNSDaysBack;
+                        aTNS :=
+                          MessageBox(PChar(aTNSString + CRLF + CRLF +
+                                     'Do you wish to continue with this request for Type & Screen?'),
+                                     PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
+                                     MB_YESNO);
+                        RestoreTopMosts;
+                        if aTNS = 7 then
+                          begin
+                            lvSelectionList.ItemIndex := i;
+                            lvSelectionListClick(self);
+                            btnRemoveClick(self);
+                            break;
+                          end;
+                      end;
+                  end;
+                break;
+              end;
+          end;
+        if uGetTnS = 1 then
+          begin
+            lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+            lblTNS.Visible := true;
+            memMessage.Text := 'TYPE + SCREEN must be added to order';
+            pnlMessage.Visible := true;
+            pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+          end;
+        if ALabTest <> nil then
+          begin
+            if ObtainCollSamp then
+              begin
+               //For BloodBank orders, this condition should never occur
+              end
+            else
+              begin
+                with ALabTest do
+                  with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                    begin
+                      x := '' ;
+                      for i := 0 to WardComment.Count-1 do
+                      x := x + WardComment.strings[i]+#13#10 ;
+                      pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                      OrderMessage(x) ;
+                    end ;
+              end;
+            with ALabTest do
+              begin
+                if ObtainComment then
+                  LoadRequiredComment(FCmtTypes.IndexOf(CurReqComment))
+                else
+                  DisableCommentPanels;
+                x := '' ;
+                for i := 0 to CurWardComment.Count-1 do
+                  x := x + CurWardComment.strings[i]+#13#10 ;
+                i :=  IndexOfCollSamp(CollSamp);
+                if i > -1 then with TCollSamp(CollSampList.Items[IndexOfCollSamp(CollSamp)]) do
+                  for i := 0 to WardComment.Count-1 do
+                    x := x + WardComment.strings[i]+#13#10 ;
+                pnlMessage.TabOrder := cboAvailTest.TabOrder + 1;
+                OrderMessage(x) ;
+              end;
+            GroupBox1.Visible := False;
+          end;
+        StatusText('');
+        Changing := False;
+      end;
+  finally                      //**SubTest
+    alist.Free;
+    aTests.Free;
+  end;
 end;
 
